#define WITH_LCD 1

#include <Wire.h>
#include <SPI.h>
#include <math.h>       /* round, floor, ceil, trunc */
#include <U8g2lib.h>     /* LCD */

#include "Thermistor.h"
#include "pin_map.h"

float Temp_F  = 0;
float Temp_C  = 0;
Thermistor Thermistor1(TEMP_0_PIN);
U8G2_ST7920_128X64_1_SW_SPI u8g2(U8G2_R0, DOGLCD_SCK , DOGLCD_MOSI, DOGLCD_CS ); // Initialize graphics controller



void setup() {
//  Serial.begin(115200);  // Initialize serial port for debugging.
  pinMode(TEMP_0_PIN, INPUT_PULLUP); // configure RAPMS TEMP_0_PIN for reading thermistor. This is MEGA pin 13 from pin_map.h
  pinMode(BEEPER_PIN, OUTPUT);
  digitalWrite(BEEPER_PIN, LOW);
  u8g2.begin(); // Write startup message to LCD
  do {
    u8g2.setFont(u8g2_font_ncenB14_tr);
    u8g2.drawStr(10, 24, "Starting...");
  } while ( u8g2.nextPage() );

  delay(1000);
}



// ----------------------------------------------------------------------------


void loop() {

  Temp_C = Thermistor1.getValue();        // read temperature from thermistor
  Serial.println(Temp_C);
  Temp_F = Temp_C * 9. / 5. + 32.;        // convert Celcius to Fahrenheit
  u8g2.firstPage();
  do {
    u8g2.setFont(u8g2_font_fub30_tf);
    u8g2.setCursor(10, 35);
    u8g2.print(Temp_F, 0);
    u8g2.setFont(u8g2_font_fub17_tf);
    u8g2.print(" F");
    u8g2.setFont(u8g2_font_fub17_tf);
    u8g2.setCursor(10, 58);
    u8g2.print(Temp_C, 0);
    u8g2.setFont(u8g2_font_fub14_tf);
    u8g2.print(" C");
  } while ( u8g2.nextPage() );

  if (Temp_C > 25) {
    digitalWrite(BEEPER_PIN, HIGH);
    delay(1000);
    digitalWrite(BEEPER_PIN, LOW);
  }

  delay(1000);
}
